/**
 * 孵化器季度任务 
 * 
 */

import {Schema} from 'mongoose';
import { baseDB } from '../../../db/mongo/dbInit';

const monthTableSchema = new Schema({
    key:{type:Number, index:true},//任务标识  格式为:YYYYMM
    type: {type:Number,index:true},//任务类型
    taskId:String,//任务id
    fuHuaQiUscc:String,//任务所属孵化器id
    submitTime:Number,//提交时间
    // relevanceId:String,//任务关联的表 financing 或 enterprise 的id  弃用
    isSubmit:Boolean,//是否提交
    quarter:Number,//数据填报季度
    year:Number,//数据填报年 2.0算分的时候加入的
    submitCount:{type:Number, default:0},//提交数量  默认0
});

var monthTableModel;
export function initModel(){
    monthTableModel = baseDB.model('monthTable', monthTableSchema);
    monthTableModel.selectOnceData = async function (paramater:object) {
        let selectInfo = await monthTableModel.findOne(paramater).exec();
        if (selectInfo) {
            if (!selectInfo.runSave) {
                selectInfo.runSave = selectInfo.save;
                selectInfo.save = save.bind(selectInfo)
            }
        }
        return selectInfo;
    }
}
export async function save(throwError=false) {
    if (!this.isModified()) return;
    await this.runSave({validateBeforeSave:false}).catch(err=>{
        console.log(err);
    });
}